<?php
/**
 * jGraphic Captcha Protection
 * @version 	1.2
 * @date        05 Sep 2014
 * @developer 	SafetyBis Ltd 
 * @copyright 	(c) 2013 www.safetybis.com , www.siteguarding.com
 * @contacts 	support@safetybis.com, support@siteguarding.com
 * @license		GNU/GPL, see http://www.gnu.org/licenses/gpl.html
 */
defined('_JEXEC') or die('Restricted access');


class PlgCaptchaJgraphiccaptchaprotection extends JPlugin
{
	
    
    
     

    
    public function onDisplay($name, $id, $class) {
        
        return $this->PrintCells().'<input type="hidden" value="none" name="'.$name.'" id="'.$id.'" >';
    }

    
    public function onCheckAnswer($code) 
	{
        	        	        	
        	
        $sg_code = JFactory::getSession()->get('sg_code', '');
        $post_sg_code = JRequest::getVar('sg_code', '');
        
                        
        if ($post_sg_code != '' && $sg_code == $post_sg_code)
        {
        	JFactory::getSession()->set('sg_code', '');
        	return true;
        }
        else {
        	JFactory::getSession()->set('sg_code', '');
        	$this->_subject->setError(JText::_('Wrong captcha code'));
        	return false;
        }
    }
    

    private function PrintCells()
	{
		$result = '';
		
		$params = array(
			'captcha_length' => 3,	
			'captcha_size' => 3	
		);
		
		$image_url = JURI::root().'/plugins/captcha/jgraphiccaptchaprotection/images/';
		
		$cell_size = intval($params['captcha_size']);
		$cell_css_size = round(270/$cell_size) - 1;
		
		$cell_margin_list = array(
			3 => 0,
			4 => 10,
			5 => 20
		);
		$cell_margin = 0;
		
		
		$result .= '<style>
		#sg_password_wra{float:left}
		#sg_password_area{margin-top:10px;background-size:100%;width:270px;height:270px; background-color:#9f9f9f;position: relative;border-left: 1px dashed #fff;border-top: 1px dashed #fff;}
		#sg_canvas{position: absolute; top:0; left:0; z-index: 1;}
		.sg_cell{width:'.$cell_css_size.'px;height:'.$cell_css_size.'px;border-right: 1px dashed #fff;border-bottom: 1px dashed #fff;position: absolute;z-index: 2;}
		</style>
		
		';
			
		
			$numbers = range(1,$cell_size*$cell_size);
			$secret_numbers = range('A', 'Z');
			shuffle($numbers);
			shuffle($secret_numbers);
			
			$session_code = array();
			foreach ($numbers as $k => $v)
			{
				$session_code[] = array('number' => $v, 'secret_number' => $secret_numbers[$k]);	
			}
			shuffle($session_code);
			shuffle($session_code);
			
			
															$sg_secret_number = '';
			for ($i = 0; $i < $params['captcha_length']; $i++)
			{
				$sg_secret_number .= $session_code[$i]['secret_number'].'-';	
			}
						JFactory::getSession()->set('sg_code', $sg_secret_number);
		
		$result .= '<div id="sg_password_wra">';
		$result .= '<img src="'.$image_url.'show.gif" height="48" width="48" />';
		
			$ttf_file = __DIR__.'/images/font.ttf';
			
			$sg_number = array();
			for ($i = 0; $i < $params['captcha_length']; $i++)
			{
				$sg_number[] = $session_code[$i]['number'];	
			}
			$click_nums = implode(" - ", $sg_number);
			 
			$im = imagecreate(220, 48);
			
						$bg = imagecolorallocate($im, 255, 255, 255);
			$textcolor = imagecolorallocate($im, 204, 0, 0);
			imagestring($im, 3, 50, 0, 'Click the numbers', $textcolor);
			
			$textcolor = imagecolorallocate($im, 0, 0, 0);
			ImageTTFText($im, $font_size = 20, $angl = 0, $x = 68 - (20*($params['captcha_length'] - 3) + 12 * ($cell_size - 3)), $y = 42, $textcolor, $ttf_file, $click_nums);
			
			ob_start();
			imagepng($im);
			$png = ob_get_clean();
			$uri = "data:image/png;base64," . base64_encode($png);
			$result .= '<img src="'. $uri . '" />';
			imagedestroy($im);
	
			$img_numbers = array();
			for ($i = 1; $i <= $cell_size*$cell_size; $i++)
			{
				
				$im = imagecreate($cell_css_size, $cell_css_size); 								$bg = imagecolortransparent($im, imagecolorallocate($im, 20, 0, 0));
								
								ImageTTFText($im, $font_size = rand(30-intval($cell_margin/2),45-intval($cell_margin/2)), $angl = rand(-5,5), $x = rand(30-$cell_margin, 35-$cell_margin), $y = rand(60-$cell_margin, 65-$cell_margin), $textcolor, $ttf_file, $i);
				
				
				ob_start();
				imagepng($im);
			
				$png = ob_get_clean();
				$uri = "data:image/png;base64," . base64_encode($png);
				
				imagedestroy($im);
				
				
				$img_numbers[$i] = $uri;	
				
				
			}
			
						
		
		$result .= '
		<div id="sg_password_area">
		<canvas id="sg_canvas" width="270" height="270"></canvas>';
		
			$cell_h = $cell_css_size+1;			$cell_w = $cell_css_size+1;			$max_w = 270;
			$start_x = 0;
			$start_y = 0;
			for ($i = 1; $i<=$cell_size*$cell_size; $i++)
			{
				$uri = $img_numbers[$numbers[$i-1]];
				$result .= '<div id="sg_cell_'.$i.'" class="sg_cell" style="top:'.$start_y.'px; left:'.$start_x.'px;background-image:url(\''.$uri.'\');" onclick="SG_DrawLine(this, \''.$secret_numbers[$i-1].'\');" >'.'</div>'; 
				$start_x += $cell_w;
				if ($start_x >= $max_w)
				{
					$start_x = 0;
					$start_y += $cell_h;	
				}	
			}
			
		$result .= '</div>
		
		<script>
		var sg_cell_h = '.$cell_h.';
		var sg_cell_w = '.$cell_w.';
		var sg_lineWidth = 40;
		var sg_line_color = "#cc0000";
		
		var start_x = 0;
		var start_y = 0;
		var step_h = sg_cell_h / 2;
		var step_w = sg_cell_w / 2;
		var last_num = 0;
		
		function SG_DrawLine(el, num)
		{
			var v_el=document.getElementById("sg_code");
			if (last_num == num) return;
			
			var c=document.getElementById("sg_canvas");
			var ctx=c.getContext("2d");
		
			var x = el.offsetLeft;
			var y = el.offsetTop;
		
			ctx.beginPath();
			ctx.arc(x+step_w,y+step_h,sg_lineWidth/2,0,2*Math.PI, false);
			ctx.fillStyle = sg_line_color;
			ctx.fill();
			ctx.lineWidth = 1;
			ctx.strokeStyle=sg_line_color;
			ctx.stroke();
			
			if (start_x > 0 || start_y > 0)
			{
				ctx.lineWidth = sg_lineWidth;
				ctx.strokeStyle=sg_line_color;
				ctx.beginPath();
				ctx.moveTo(start_x, start_y);
				ctx.lineTo(x+step_w,y+step_h);
				ctx.stroke();
			}
			else v_el.value = "";
			
			start_x = x+step_w;
			start_y = y+step_h;
			
			v_el.value = v_el.value + num + "-";
			last_num = num;
		}
		
		function SG_Refresh()
		{
			var v_el=document.getElementById("sg_code");
			var c=document.getElementById("sg_canvas");
			var ctx=c.getContext("2d");
			ctx.clearRect(0, 0, c.width, c.height);	
			start_x = start_y = last_num = 0;
			v_el.value = "";
		}
		
		</script>
		<p><a style="margin-top:5px" class="button" href="javascript:;" onclick="SG_Refresh()">Clear</a></p>
		<input type="hidden" id="sg_code" name="sg_code" value="" />
		';
		
		$result .= '</div>';
		
		return $result;
	}
    
    
    

}